% test for edge detection and representation using a bandlet transform
%
%   Copyright (c) 2006 Gabriel Peyre

path(path, 'toolbox/');
clear options;

name = 'lena';
name = 'barb';
name = 'boat';
name = 'disk';
name = 'fingerprint';
n = 128;
n0 = n;
if strcmp(name, 'disk')
    n0 = n;
end
M = load_image(name,n0);
% crop the image
M = rescale( M(end/2-n/2+1:end/2+n/2,end/2-n/2+1:end/2+n/2 ) );


% width of the square
options.w = 8; 
% threshold used for detection
options.T = 20/256;
options.n = n;
options.Jhaar = 4; % number of scales for the 1D haar transform
% The default penalty for geometry is 1.
% Here I put a stronger penalty to enforce that geometry is
% detected only for real edges.
options.geometry_weight = 3; % price to pay for the geometry

% compute the geometry for the bandlet transform
options.ti = 1; % use translation invariant haar for detection
disp('--> Extracting geometry');
options.remove_mean = 1;
G = compute_geometry( M, options );

% display the geometry
clf;
plot_geometry(G, M, options);

% perform the transform
options.dir = 1;
options.ti = 0;
MB = perform_bandlet_transform( M, G, options );

% here you can embbed the watermarks ...
% MBT = ...

v = MB(:,1);
for j=1:options.Jhaar
    c{j} = v(end/2^j+1:2*end/2^j);
end

% instead of embeding a watermark, I simply remove 
% small amplitude coefficient to perform a bandlet approximation
MBT = perform_thresholding(MB, 25/256);

% now we reconstruct
options.dir = -1;
M1 = perform_bandlet_transform( MBT, G, options );


figure;
display_image_layout(  {M M1}, {'Image' 'Reconstructed' }, 1 );