% test for geometry detection on a wavelet transform
%
%   Copyright (c) 2006 Gabriel Peyre

path(path, 'toolbox/');
clear options;

name = 'lena';
name = 'barb';
n = 128;
M = load_image(name);
% M = load_image('square', n);
M = rescale( M(end/2-n/2+1:end/2+n/2,end/2-n/2+1:end/2+n/2 ) );

options.wavelet_type = 'biorthogonal';
options.wavelet_vm = 3;
Jmin = 4;
MW = perform_atrou_transform(M,Jmin,options);

options.w = 8; 
options.T = 10/256;
options.n = n;

% compute the geometry for the bandlet transform
A = rescale(MW{1});
tic;
G = compute_geometry( A, options );
toc;

clf;
plot_geometry(G, A, options);

% perform the transform
options.dir = 1;
MB = perform_bandlet_transform( A, G, options );

% perform thresholding
T = 10/256;
MB = MB .* (abs(MB)>T);

options.dir = -1;
A1 = perform_bandlet_transform( MB, G, options );

display_image_layout(  {M A A1}, {'Image' 'Wavelet coefficients' 'Reconstructed' }, 1 );